function varargout = GUI(varargin)
% GUI M-file for GUI.fig
%      GUI, by itself, creates a new GUI or raises the existing
%      singleton*.
%
%      H = GUI returns the handle to a new GUI or the handle to
%      the existing singleton*.
%
%      GUI('CALLBACK',hObject,eventData,handles,...) calls the local
%      function named CALLBACK in GUI.M with the given input arguments.
%
%      GUI('Property','Value',...) creates a new GUI or raises the
%      existing singleton*.  Starting from the left, property value pairs are
%      applied to the GUI before GUI_OpeningFunction gets called.  An
%      unrecognized property name or invalid value makes property application
%      stop.  All inputs are passed to GUI_OpeningFcn via varargin.
%
%      *See GUI Options on GUIDE's Tools menu.  Choose "GUI allows only one
%      instance to run (singleton)".
%
% See also: GUIDE, GUIDATA, GUIHANDLES

% Copyright 2002-2003 The MathWorks, Inc.

% Edit the above text to modify the response to help GUI

% Last Modified by GUIDE v2.5 07-Dec-2005 14:06:12

% Begin initialization code - DO NOT EDIT
gui_Singleton = 1;
gui_State = struct('gui_Name',       mfilename, ...
                   'gui_Singleton',  gui_Singleton, ...
                   'gui_OpeningFcn', @GUI_OpeningFcn, ...
                   'gui_OutputFcn',  @GUI_OutputFcn, ...
                   'gui_LayoutFcn',  [] , ...
                   'gui_Callback',   []);
if nargin && ischar(varargin{1})
    gui_State.gui_Callback = str2func(varargin{1});
end

if nargout
    [varargout{1:nargout}] = gui_mainfcn(gui_State, varargin{:});
else
    gui_mainfcn(gui_State, varargin{:});
end
% End initialization code - DO NOT EDIT


% --- Executes just before GUI is made visible.
function GUI_OpeningFcn(hObject, eventdata, handles, varargin)
% This function has no output args, see OutputFcn.
% hObject    handle to figure
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)
% varargin   command line arguments to GUI (see VARARGIN)

% Choose default command line output for GUI
handles.output = hObject;

% Update handles structure
guidata(hObject, handles);

% UIWAIT makes GUI wait for user response (see UIRESUME)
% uiwait(handles.figure1);


% --- Outputs from this function are returned to the command line.
function varargout = GUI_OutputFcn(hObject, eventdata, handles) 
% varargout  cell array for returning output args (see VARARGOUT);
% hObject    handle to figure
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)

% Get default command line output from handles structure
varargout{1} = handles.output;

% --- Executes on button press in loadPic.
function loadPic_Callback(hObject, eventdata, handles)
% hObject    handle to loadPic (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)


% open an image file
[filename, pathname] = uigetfile({'*.jpg';'*.bmp';'*.gif';'*.*'}, 'Pick an Image File');
picOriginal = imread([pathname,filename]);    % read in the image file
axes(handles.picOriginal);       % display the image file in picOriginal
imshow(picOriginal);
set(handles.loadedImage,'String', filename);

%handles.picOriginal = picOriginal; % pass picOriginal to a handle to share with other functions
handles.loadPic=picOriginal;
guidata(hObject, handles);


% --- Executes on selection change in deblurOption.
function deblurOption_Callback(hObject, eventdata, handles)
% hObject    handle to deblurOption (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)

% Hints: contents = get(hObject,'String') returns deblurOption contents as cell array
%        contents{get(hObject,'Value')} returns selected item from deblurOption


% --- Executes on button press in boxMotion.
function boxMotion_Callback(hObject, eventdata, handles)
% hObject    handle to boxMotion (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)

% Hint: get(hObject,'Value') returns toggle state of boxMotion


% --- Executes on button press in boxGaussian.
function boxGaussian_Callback(hObject, eventdata, handles)
% hObject    handle to boxGaussian (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)

% Hint: get(hObject,'Value') returns toggle state of boxGaussian

% --- Executes on button press in boxAveraging.
function boxAveraging_Callback(hObject, eventdata, handles)
% hObject    handle to boxAveraging (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)

% Hint: get(hObject,'Value') returns toggle state of boxAveraging


% --- Executes on button press in boxDisk.
function boxDisk_Callback(hObject, eventdata, handles)
% hObject    handle to boxDisk (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)

% Hint: get(hObject,'Value') returns toggle state of boxDisk


function diskRadius_Callback(hObject, eventdata, handles)
% hObject    handle to diskRadius (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)

% Hints: get(hObject,'String') returns contents of diskRadius as text
%        str2double(get(hObject,'String')) returns contents of diskRadius as a double





function motionLen_Callback(hObject, eventdata, handles)
% hObject    handle to motionLen (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)

% Hints: get(hObject,'String') returns contents of motionLen as text
%        str2double(get(hObject,'String')) returns contents of motionLen as a double




% --- Executes on slider movement.

function motionAngle_Callback(hObject, eventdata, handles)
% hObject    handle to motionAngle (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)

% Hints: get(hObject,'Value') returns position of slider
%        get(hObject,'Min') and get(hObject,'Max') to determine range of slider
NewVal = get(hObject, 'Value');
set(handles.angleEdit,'String',NewVal)


function gaussianHsize_Callback(hObject, eventdata, handles)
% hObject    handle to gaussianHsize (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)

% Hints: get(hObject,'String') returns contents of gaussianHsize as text
%        str2double(get(hObject,'String')) returns contents of gaussianHsize as a double



function gaussianSigma_Callback(hObject, eventdata, handles)
% hObject    handle to gaussianSigma (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)

% Hints: get(hObject,'String') returns contents of gaussianSigma as text
%        str2double(get(hObject,'String')) returns contents of gaussianSigma as a double




function averagingHsize_Callback(hObject, eventdata, handles)
% hObject    handle to averagingHsize (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)

% Hints: get(hObject,'String') returns contents of averagingHsize as text
%        str2double(get(hObject,'String')) returns contents of averagingHsize as a double



function angleEdit_Callback(hObject, eventdata, handles)
% hObject    handle to angleEdit (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)

% Hints: get(hObject,'String') returns contents of angleEdit as text
%        str2double(get(hObject,'String')) returns contents of angleEdit as a double





% --- Executes on button press in magic.
function magic_Callback(hObject, eventdata, handles)
% hObject    handle to magic (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)

picBlurred=handles.loadPic;

%look at the check boxes, and blur the original pic accordingly 
%checkedMotion = get(handles.boxMotion,'Value');
%checkedGaussian = get(handles.boxGaussian,'Value');
%checkedAveraging = get(handles.boxAveraging,'Value');
%checkedDisk = get(handles.boxDisk,'Value');
%motionLen = str2double(get(handles.motionLen,'String'));
%motionAngle = str2double(get(handles.angleEdit,'String'));
%gaussianHsize = str2double(get(handles.gaussianHsize, 'String'))
%gaussianSigma = str2double(get(handles.gaussianSigma, 'String'))
filterMotion = 1;
filterGaussian = 1;
filterAveraging = 1;
filterDisk = 1;

%look for motion blur checkmark
if get(handles.boxMotion,'Value')%checkedMotion
   filterMotion = fspecial('motion', str2double(get(handles.motionLen,'String')), str2double(get(handles.angleEdit,'String')));%motionLen, motionAngle);

end

%look for gaussian blur checkmark
if get(handles.boxGaussian,'Value')%checkedGaussian
   filterGaussian = fspecial('gaussian', str2double(get(handles.gaussianHsize, 'String')), str2double(get(handles.gaussianSigma, 'String')));%gaussianHsize, gaussianSigma);
end

%look for averaging blur checkmark
if get(handles.boxAveraging,'Value')%checkedAveraging
   filterAveraging = fspecial('average', str2double(get(handles.averagingHsize, 'String')));
end

%look for disk blur checkmark
if get(handles.boxDisk,'Value')%checkedDisk
   filterDisk = fspecial('disk', str2double(get(handles.diskRadius, 'String')));   
end

%make a composite filter by convolving all the above filters
filterConv = conv2(filterMotion, filterGaussian);
filterConv = conv2(filterConv, filterAveraging);
filterConv = conv2(filterConv, filterDisk);

%now blur the image accordingly
if get(handles.boxAddblur, 'Value')
    picBlurred = imfilter(picBlurred, filterConv, 'replicate');
elseif  get(handles.boxMotion, 'Value')
    filterConv = filterMotion;
else filterConv = ones(1,3);
end
axes(handles.picBlurred);       % display the image file in picBlurred
imshow(picBlurred);

%*******************************************************************
%here we'll deblur the picture:
if get(handles.boxEdgeTaper, 'Value')
    picBlurred = edgetaper(picBlurred, filterConv);
end

if get(handles.deblurOption,'Value')==2
    picDeblurred = deconvlucy(picBlurred, filterConv);
end
if get(handles.deblurOption,'Value')==3
    [picDeblurred, PSF] = deconvblind(picBlurred, filterConv);
end
if get(handles.deblurOption,'Value')==4
    picDeblurred = deconvreg(picBlurred, filterConv);
end
if get(handles.deblurOption,'Value')==5    
    picDeblurred = deconvwnr(picBlurred, filterConv);
end

axes(handles.picDeblurred);       % display the image file in picBlurred
imshow(picDeblurred);
% --- Executes during object creation, after setting all properties.
function deblurOption_CreateFcn(hObject, eventdata, handles)
% hObject    handle to deblurOption (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    empty - handles not created until after all CreateFcns called

% Hint: popupmenu controls usually have a white background on Windows.
%       See ISPC and COMPUTER.
if ispc
    set(hObject,'BackgroundColor','white');
else
    set(hObject,'BackgroundColor',get(0,'defaultUicontrolBackgroundColor'));
end


% --- Executes during object creation, after setting all properties.
function boxMotion_CreateFcn(hObject, eventdata, handles)
% hObject    handle to boxMotion (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    empty - handles not created until after all CreateFcns called


% --- Executes during object creation, after setting all properties.
function motionLen_CreateFcn(hObject, eventdata, handles)
% hObject    handle to motionLen (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    empty - handles not created until after all CreateFcns called

% Hint: edit controls usually have a white background on Windows.
%       See ISPC and COMPUTER.
if ispc
    set(hObject,'BackgroundColor','white');
else
    set(hObject,'BackgroundColor',get(0,'defaultUicontrolBackgroundColor'));
end


% --- Executes during object creation, after setting all properties.
function motionAngle_CreateFcn(hObject, eventdata, handles)
% hObject    handle to motionAngle (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    empty - handles not created until after all CreateFcns called

% Hint: slider controls usually have a light gray background, change
%       'usewhitebg' to 0 to use default.  See ISPC and COMPUTER.
usewhitebg = 1;
if usewhitebg
    set(hObject,'BackgroundColor',[.9 .9 .9]);
else
    set(hObject,'BackgroundColor',get(0,'defaultUicontrolBackgroundColor'));
end


% --- Executes during object creation, after setting all properties.
function angleEdit_CreateFcn(hObject, eventdata, handles)
% hObject    handle to angleEdit (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    empty - handles not created until after all CreateFcns called

% Hint: edit controls usually have a white background on Windows.
%       See ISPC and COMPUTER.
if ispc
    set(hObject,'BackgroundColor','white');
else
    set(hObject,'BackgroundColor',get(0,'defaultUicontrolBackgroundColor'));
end


% --- Executes during object creation, after setting all properties.
function boxGaussian_CreateFcn(hObject, eventdata, handles)
% hObject    handle to boxGaussian (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    empty - handles not created until after all CreateFcns called


% --- Executes during object creation, after setting all properties.
function gaussianHsize_CreateFcn(hObject, eventdata, handles)
% hObject    handle to gaussianHsize (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    empty - handles not created until after all CreateFcns called

% Hint: edit controls usually have a white background on Windows.
%       See ISPC and COMPUTER.
if ispc
    set(hObject,'BackgroundColor','white');
else
    set(hObject,'BackgroundColor',get(0,'defaultUicontrolBackgroundColor'));
end


% --- Executes during object creation, after setting all properties.
function gaussianSigma_CreateFcn(hObject, eventdata, handles)
% hObject    handle to gaussianSigma (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    empty - handles not created until after all CreateFcns called

% Hint: edit controls usually have a white background on Windows.
%       See ISPC and COMPUTER.
if ispc
    set(hObject,'BackgroundColor','white');
else
    set(hObject,'BackgroundColor',get(0,'defaultUicontrolBackgroundColor'));
end


% --- Executes during object creation, after setting all properties.
function boxAveraging_CreateFcn(hObject, eventdata, handles)
% hObject    handle to boxAveraging (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    empty - handles not created until after all CreateFcns called


% --- Executes during object creation, after setting all properties.
function averagingHsize_CreateFcn(hObject, eventdata, handles)
% hObject    handle to averagingHsize (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    empty - handles not created until after all CreateFcns called

% Hint: edit controls usually have a white background on Windows.
%       See ISPC and COMPUTER.
if ispc
    set(hObject,'BackgroundColor','white');
else
    set(hObject,'BackgroundColor',get(0,'defaultUicontrolBackgroundColor'));
end


% --- Executes during object creation, after setting all properties.
function boxDisk_CreateFcn(hObject, eventdata, handles)
% hObject    handle to boxDisk (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    empty - handles not created until after all CreateFcns called


% --- Executes during object creation, after setting all properties.
function diskRadius_CreateFcn(hObject, eventdata, handles)
% hObject    handle to diskRadius (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    empty - handles not created until after all CreateFcns called

% Hint: edit controls usually have a white background on Windows.
%       See ISPC and COMPUTER.
if ispc
    set(hObject,'BackgroundColor','white');
else
    set(hObject,'BackgroundColor',get(0,'defaultUicontrolBackgroundColor'));
end


% --- Executes during object creation, after setting all properties.
function picBlurred_CreateFcn(hObject, eventdata, handles)
% hObject    handle to picBlurred (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    empty - handles not created until after all CreateFcns called

% Hint: place code in OpeningFcn to populate picBlurred




% --- Executes during object creation, after setting all properties.
function picOriginal_CreateFcn(hObject, eventdata, handles)
% hObject    handle to picOriginal (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    empty - handles not created until after all CreateFcns called

% Hint: place code in OpeningFcn to populate picOriginal


% --- Executes during object creation, after setting all properties.
function picDeblurred_CreateFcn(hObject, eventdata, handles)
% hObject    handle to picDeblurred (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    empty - handles not created until after all CreateFcns called

% Hint: place code in OpeningFcn to populate picDeblurred














% --- Executes on button press in boxAddblur.
function boxAddblur_Callback(hObject, eventdata, handles)
% hObject    handle to boxAddblur (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)

% Hint: get(hObject,'Value') returns toggle state of boxAddblur




% --- Executes on button press in boxEdgeTaper.
function boxEdgeTaper_Callback(hObject, eventdata, handles)
% hObject    handle to boxEdgeTaper (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)

% Hint: get(hObject,'Value') returns toggle state of boxEdgeTaper


