function varargout = blind(varargin)
% BLIND M-file for blind.fig
%      BLIND, by itself, creates a new BLIND or raises the existing
%      singleton*.
%
%      H = BLIND returns the handle to a new BLIND or the handle to
%      the existing singleton*.
%
%      BLIND('CALLBACK',hObject,eventData,handles,...) calls the local
%      function named CALLBACK in BLIND.M with the given input arguments.
%
%      BLIND('Property','Value',...) creates a new BLIND or raises the
%      existing singleton*.  Starting from the left, property value pairs are
%      applied to the GUI before blind_OpeningFunction gets called.  An
%      unrecognized property name or invalid value makes property application
%      stop.  All inputs are passed to blind_OpeningFcn via varargin.
%
%      *See GUI Options on GUIDE's Tools menu.  Choose "GUI allows only one
%      instance to run (singleton)".
%
% See also: GUIDE, GUIDATA, GUIHANDLES

% Copyright 2002-2003 The MathWorks, Inc.

% Edit the above text to modify the response to help blind

% Last Modified by GUIDE v2.5 07-Dec-2005 13:36:45

% Begin initialization code - DO NOT EDIT
gui_Singleton = 1;
gui_State = struct('gui_Name',       mfilename, ...
                   'gui_Singleton',  gui_Singleton, ...
                   'gui_OpeningFcn', @blind_OpeningFcn, ...
                   'gui_OutputFcn',  @blind_OutputFcn, ...
                   'gui_LayoutFcn',  [] , ...
                   'gui_Callback',   []);
if nargin && ischar(varargin{1})
    gui_State.gui_Callback = str2func(varargin{1});
end

if nargout
    [varargout{1:nargout}] = gui_mainfcn(gui_State, varargin{:});
else
    gui_mainfcn(gui_State, varargin{:});
end
% End initialization code - DO NOT EDIT


% --- Executes just before blind is made visible.
function blind_OpeningFcn(hObject, eventdata, handles, varargin)
% This function has no output args, see OutputFcn.
% hObject    handle to figure
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)
% varargin   command line arguments to blind (see VARARGIN)

% Choose default command line output for blind
handles.output = hObject;

% Update handles structure
guidata(hObject, handles);

% UIWAIT makes blind wait for user response (see UIRESUME)
% uiwait(handles.figure1);


% --- Outputs from this function are returned to the command line.
function varargout = blind_OutputFcn(hObject, eventdata, handles) 
% varargout  cell array for returning output args (see VARARGOUT);
% hObject    handle to figure
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)

% Get default command line output from handles structure
varargout{1} = handles.output;


% --- Executes on button press in buttonDeblur.
function buttonDeblur_Callback(hObject, eventdata, handles)
% hObject    handle to buttonDeblur (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)
picOriginal = handles.buttonLoad;

%determine if we need to resize the image
sides=size(picOriginal);
maxPixels = str2double(get(handles.maxPixels, 'String'));
if sides(1)*sides(2) > maxPixels
    scalingFactor = maxPixels/(sides(1)*sides(2));
    blurredImage = imresize(picOriginal, scalingFactor);
end
set(handles.newSize,'String', size(blurredImage));
figure(1); imshow(blurredImage); %display in new window


%this block converts a string that has comma-separated numbers into an
%actual array of numbers
INITPSFstring = get(handles.initpsf, 'String');
INITPSFindex = 1;
INITPSF=[0];
for i = 1:length(INITPSFstring)
    if str2num(INITPSFstring(i))~=NaN
        INITPSF(INITPSFindex) = 10*INITPSF(INITPSFindex)+str2num(INITPSFstring(i));
    elseif INITPSFstring(i) == ','
        INITPSFindex = INITPSFindex + 1;
        INITPSF(INITPSFindex)=0;
    end
end

%here are some more paramaters used by deconvblind()
NUMIT = str2double(get(handles.numit, 'String'));
DAMPAR =  str2double(get(handles.dampar, 'String'));
WEIGHT = str2double(get(handles.weight, 'String'));
if get(handles.boxEdgeTaper, 'Value')
    blurredImage = edgetaper(blurredImage, INITPSF);
end
[deblurredImage, outputPSF] = deconvblind(blurredImage, INITPSF, NUMIT); %, DAMPAR, WEIGHT);
set(handles.outputPSF,'String', outputPSF);

size(deblurredImage);
axes(handles.picDeblurred);       % display the image file in picOriginal
imshow(deblurredImage);
figure(2); imshow(deblurredImage); %display in new window



function initpsf_Callback(hObject, eventdata, handles)
% hObject    handle to initpsf (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)

% Hints: get(hObject,'String') returns contents of initpsf as text
%        str2double(get(hObject,'String')) returns contents of initpsf as a double


% --- Executes during object creation, after setting all properties.
function initpsf_CreateFcn(hObject, eventdata, handles)
% hObject    handle to initpsf (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    empty - handles not created until after all CreateFcns called

% Hint: edit controls usually have a white background on Windows.
%       See ISPC and COMPUTER.
if ispc
    set(hObject,'BackgroundColor','white');
else
    set(hObject,'BackgroundColor',get(0,'defaultUicontrolBackgroundColor'));
end



function numit_Callback(hObject, eventdata, handles)
% hObject    handle to numit (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)

% Hints: get(hObject,'String') returns contents of numit as text
%        str2double(get(hObject,'String')) returns contents of numit as a double


% --- Executes during object creation, after setting all properties.
function numit_CreateFcn(hObject, eventdata, handles)
% hObject    handle to numit (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    empty - handles not created until after all CreateFcns called

% Hint: edit controls usually have a white background on Windows.
%       See ISPC and COMPUTER.
if ispc
    set(hObject,'BackgroundColor','white');
else
    set(hObject,'BackgroundColor',get(0,'defaultUicontrolBackgroundColor'));
end



function dampar_Callback(hObject, eventdata, handles)
% hObject    handle to dampar (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)

% Hints: get(hObject,'String') returns contents of dampar as text
%        str2double(get(hObject,'String')) returns contents of dampar as a double


% --- Executes during object creation, after setting all properties.
function dampar_CreateFcn(hObject, eventdata, handles)
% hObject    handle to dampar (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    empty - handles not created until after all CreateFcns called

% Hint: edit controls usually have a white background on Windows.
%       See ISPC and COMPUTER.
if ispc
    set(hObject,'BackgroundColor','white');
else
    set(hObject,'BackgroundColor',get(0,'defaultUicontrolBackgroundColor'));
end



function weight_Callback(hObject, eventdata, handles)
% hObject    handle to weight (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)

% Hints: get(hObject,'String') returns contents of weight as text
%        str2double(get(hObject,'String')) returns contents of weight as a double


% --- Executes during object creation, after setting all properties.
function weight_CreateFcn(hObject, eventdata, handles)
% hObject    handle to weight (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    empty - handles not created until after all CreateFcns called

% Hint: edit controls usually have a white background on Windows.
%       See ISPC and COMPUTER.
if ispc
    set(hObject,'BackgroundColor','white');
else
    set(hObject,'BackgroundColor',get(0,'defaultUicontrolBackgroundColor'));
end


% --- Executes on button press in buttonLoad.
function buttonLoad_Callback(hObject, eventdata, handles)
% hObject    handle to buttonLoad (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)

% open an image file
[filename, pathname] = uigetfile({'*.jpg';'*.bmp';'*.gif';'*.*'}, 'Pick an Image File');
picOriginal = imread([pathname,filename]);    % read in the image file
set(handles.imageSize,'String', size(picOriginal));
  
axes(handles.picOriginal);       % display the image file in picOriginal
imshow(picOriginal);
set(handles.loadedImage,'String', filename);

%handles.picOriginal = picOriginal; % pass picOriginal to a handle to share with other functions
handles.buttonLoad=picOriginal;
guidata(hObject, handles);

function maxPixels_Callback(hObject, eventdata, handles)
% hObject    handle to maxPixels (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)

% Hints: get(hObject,'String') returns contents of maxPixels as text
%        str2double(get(hObject,'String')) returns contents of maxPixels as a double


% --- Executes during object creation, after setting all properties.
function maxPixels_CreateFcn(hObject, eventdata, handles)
% hObject    handle to maxPixels (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    empty - handles not created until after all CreateFcns called

% Hint: edit controls usually have a white background on Windows.
%       See ISPC and COMPUTER.
if ispc
    set(hObject,'BackgroundColor','white');
else
    set(hObject,'BackgroundColor',get(0,'defaultUicontrolBackgroundColor'));
end


% --- Executes on button press in boxEdgeTaper.
function boxEdgeTaper_Callback(hObject, eventdata, handles)
% hObject    handle to boxEdgeTaper (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)

% Hint: get(hObject,'Value') returns toggle state of boxEdgeTaper


